import { Client } from '../services/api';
import { mapAssetTokenData } from '../utils/helper';

export const SET_TRANSACTIONS = 'SET_TRANSACTIONS';
export const SET_TOTAL_TRANSACTIONS = 'SET_TOTAL_TRANSACTIONS';
export const SET_BLOCKS = 'SET_BLOCKS';

export const setTransactions = (items = []) => ({
  type: SET_TRANSACTIONS,
  items,
});

export const setTotalNumberOfTransactions = (numberOfTransactions = 0) => ({
  type: SET_TOTAL_TRANSACTIONS,
  numberOfTransactions,
});

export const setBlocks = (items = []) => ({
  type: SET_BLOCKS,
  items,
});

export const loadBlocks = () => async (dispatch) => {
  let {items} = await Client.getBlocks({
    limit: 15,
  });
  dispatch(setBlocks(items));
};

export const loadTransactions = () => async (dispatch) => {
  const result = await Client.getTransfers({
    limit: 15,
  });

  const transfers = mapAssetTokenData(result)
  dispatch(setTransactions(transfers));
};

export const loadTotalNumberOfTransactions = () => async (dispatch, getState) => {

  // let totalTransactions = await Client.getTotalNumberOfTransactions();
  // dispatch(setTotalNumberOfTransactions(totalTransactions));
};
