import { Client } from '../services/api';
import { setTokenBalances } from './account';
// import rebuildList from '../utils/rebuildList';
// import rebuildToken20List from '../utils/rebuildToken20List';
// import { FormatNumberByDecimals, FormatNumberByDecimalsBalance } from '../utils/number'
import { fromAmount, gets, mapTokenData } from '../utils/helper';
import { ONE_UNIT } from '../constants';

export const SET_ACTIVE_WALLET = 'SET_ACTIVE_WALLET';
export const SET_WALLET_LOADING = 'SET_WALLET_LOADING';

export const setActiveWallet = (wallet) => ({
  type: SET_ACTIVE_WALLET,
  wallet,
});

export const reloadWallet = () => async (dispatch, getState) => {
  let {app} = getState();

  if (app.account.isLoggedIn) {
    try {
      let {assets_balances, frozen_for_bandwidth, frozen_for_energy, delegated, token_balances, ...wallet} = await Client.getAccountByAddressNew(app.account.address);
      const mcashBalance = wallet.balance ? wallet.balance / ONE_UNIT : 0

      let sentDelegateBandwidth = 0;
      if (delegated && delegated.sent_delegated_bandwidth) {
        for (let i = 0; i < delegated.sent_delegated_bandwidth.length; i++) {
          sentDelegateBandwidth = sentDelegateBandwidth + delegated.sent_delegated_bandwidth[i]['frozen_balance_for_bandwidth'];
        }
      }

      const frozenBandwidth = frozen_for_bandwidth ? frozen_for_bandwidth.frozen_balance : 0;

      let sentDelegateResource = 0;
      if (delegated && delegated.sent_delegated_resource) {
        for (let i = 0; i < delegated.sent_delegated_resource.length; i++) {
          sentDelegateResource = sentDelegateResource + delegated.sent_delegated_resource[i]['frozen_balance_for_energy'];
        }
      }

      const frozenEnergy = frozen_for_energy && frozen_for_energy.frozen_balance ? frozen_for_energy.frozen_balance : 0;
      wallet.frozenEnergy = frozenEnergy
      wallet.frozenMcash = sentDelegateBandwidth + frozenBandwidth + sentDelegateResource + frozenEnergy;
      wallet.mcashBalance = wallet ? +fromAmount(wallet.balance) : ''

      // wallet.exchanges = rebuildList(exchanges, ['first_token_id', 'second_token_id'], ['first_token_balance', 'second_token_balance']);
      wallet.exchanges = [];
      // wallet.tokenBalances = rebuildList(tokenBalances, 'name', 'balance');
      wallet.tokenBalances = mapTokenData(assets_balances, wallet.token_map, 'asset_id');
      wallet.tokenBalances = mapTokenData(assets_balances, wallet.token_map, 'asset_id');
      // const balances_new = rebuildList(assetsBalances, 'name', 'balance');
      const tokens = mapTokenData(assets_balances, wallet.token_map, 'asset_id');
      const tokens20 = mapTokenData(token_balances, wallet.token_map);

      dispatch(setActiveWallet(wallet));
      dispatch(setTokenBalances(tokens, tokens20, frozen_for_bandwidth, frozen_for_energy, delegated, mcashBalance));
    } catch (err) {
      console.error(err)
    }
  }

};

export const setWalletLoading = (loading = true) => ({
  type: SET_WALLET_LOADING,
  loading,
});
