import React, {Component} from 'react';
import {HrefLink} from "../common/Links";

export default class Faq extends Component {

  render() {

    return (
        <main className="container header-overlap news">
          <div className="row">
            <div className="col-md-12">
              <div className="card">
                <div className="card-body">

                  <p>MCASH respects copyright law and expects its users to do the same. In accordance with the Digital
                    Millennium Copyright Act (“DMCA”), the text of which may be found on the U.S. Copyright Office web
                    site at <a style={{textDecoration: 'underline'}}
                               href="http://www.copyright.gov/legislation/dmca.pdf">http://www.copyright.gov/legislation/dmca.pdf</a> ,
                    MCASH will respond expeditiously to notices of alleged copyright infringement that are reported to
                    MCASH’s Designated Copyright Agent, identified in the sample Notice below.<br/>
                    To file a copyright infringement notification with MCASH (“Notice”), you will need to send a written
                    communication that includes substantially the following (please consult your legal counsel or see
                    Section 512(c)(3) of the DMCA to confirm these requirements):
                  </p>
                  <ul>
                    <li>
                      A physical or electronic signature of a person authorized to act on behalf of the owner of an
                      exclusive right that is allegedly infringed.
                    </li>
                    <li>
                      Identification of the copyrighted work claimed to have been infringed, or, if multiple copyrighted
                      works at a single online site are covered by a single notification, a representative list of such
                      works at that site.
                    </li>
                    <li>
                      Identification of the material that is claimed to be infringing or to be the subject of infringing
                      activity and that is to be removed or access to which is to be disabled, and information
                      reasonably sufficient to permit the service provider to locate the material. Providing URLs in the
                      body of an email is the best way to help us locate content quickly.
                    </li>
                    <li>
                      Information reasonably sufficient to permit the service provider to contact the complaining party,
                      such as an address, telephone number, and, if available, an electronic mail address at which the
                      complaining party may be contacted.
                    </li>
                    <li>
                      A statement that the complaining party has a good faith belief that use of the material in the
                      manner complained of is not authorized by the copyright owner, its agent, or the law.
                    </li>
                    <li>
                      A statement that the information in the notification is accurate, and under penalty of perjury,
                      that the complaining party is authorized to act on behalf of the owner of an exclusive right that
                      is allegedly infringed.
                    </li>

                  </ul>
                  <p>
                    Deliver this Notice, with all items completed, to MCASH’s Designated Copyright Agent:
                  </p>

                  <p>
                    DMCA Complaints<br/>
                    MCASH<br/>
                    301 Howard St., Suite 2000<br/>
                    San Francisco, California 94105<br/>
                    Attention: MCASH Copyright Agent<br/>
                    <a style={{textDecoration: 'underline'}}>copyright@tron.network</a>
                  </p>

                  <p>
                    Please note that under Section 512(f) of the DMCA, any person who knowingly materially misrepresents
                    that material or activity is infringing may be subject to liability for damages.
                  </p>

                  <p>
                    Please also note that the information provided in this legal Notice may be forwarded to the person
                    who provided the allegedly infringing content.
                  </p>

                  <p>
                    MCASH does not permit copyright infringing activities on its websites and will, if properly notified
                    that files infringe a copyright, remove or disable access to such files.
                  </p>

                  <p>
                    MCASH reserves the right to remove or disable access to files or links to allegedly infringing
                    material without prior notice.
                  </p>

                  <h3>Counter-Notification</h3>
                  <p>
                    If we remove or disable access to your content for infringing someone else’s copyright, and you
                    believe we removed it by mistake, please go to the Copyright Counter-notification page to access the
                    instructions regarding filing a DMCA counter-notice.
                  </p>
                  <p>
                    Please note that under Section 512(f) of the DMCA, any person who knowingly materially misrepresents
                    that material or activity was removed or disabled by mistake or misidentification may be subject to
                    liability.
                  </p>
                  <h3>Repeat Infringers</h3>
                  <p>
                    Not all MCASH services limit their usage to registered users or other account holders. For services
                    that do, MCASH will terminate registered users or other account holders whom it determines to be
                    repeat infringers. If you believe that a registered user or other account holder is an infringer,
                    please follow the instructions above to contact MCASH’s Designated Copyright Agent and provide
                    information sufficient for MCASH to verify that the registered user or other account holder is an
                    infringer.
                  </p>

                  <h3>Subpoenas</h3>
                  <p>
                    MCASH may be required to disclose information to individuals asserting rights under the Digital
                    Millennium Copyright Act or other intellectual property laws. You authorize MCASH to release
                    information about you if required by law or subpoena without notice to you.
                  </p>


                </div>
              </div>
            </div>
          </div>
        </main>
    )
  }
}
