import React from 'react';
import { TRXPrice } from './Price';
import { FormattedNumber } from 'react-intl';
import { Link } from 'react-router-dom';
import { CHAIN_SYMBOL, ONE_UNIT } from '../../constants';
import { showAmount } from '../../utils/helper';

export const NameWithId = ({value, type, notamount = false, totoken = false, br = false, valueRange = true}) => {
  const token = value.token ? value.token : {}
  if (token && token.symbol === CHAIN_SYMBOL) {
    return <TRXPrice valueRange={valueRange} amount={value.amount / ONE_UNIT}/>
  }
  const mapAmount = token.decimals && value.amount ? value.amount / Math.pow(10, token.decimals) : value.amount
  return (
    <span>
      {
        !notamount &&
        <span className="mr-1">
          {
            valueRange ? (
              showAmount(mapAmount, token.decimals)
            ) : (
              isNaN(value.amount) ? '-' :
                <FormattedNumber
                  value={mapAmount}
                  maximumFractionDigits={token.decimals || 0}
                />
            )
          }
        </span>
      }
      {br ? <br/> : ''}
      {
        totoken ? (
          <Link to={`/token/${token.asset_id}`}>
            {
              type === 'symbol' ? (
                <span className="mr-1">
                  {token.symbol ? token.symbol : token.name}
                </span>
              ) : <span className="mr-1">{token.name}</span>
            }
          </Link>
        ) : (
          type === 'symbol' ? (
            <span className="mr-1">
                {token.symbol ? token.symbol : token.name}
              </span>
          ) : <span className="mr-1">{token.name}</span>
        )
      }
      {typeof token.asset_id !== 'undefined' && (
        <span style={{color: '#808080', fontSize: '12px'}}>[ID:{token.asset_id}]</span>
      )}
    </span>
  )
  // return (
  //   value.map_token_name === 'MCASH' ?
  //     <TRXPrice amount={value.map_amount}/> :
  //     <span>
  //       {
  //         !notamount &&
  //         <span className="mr-1">
  //           {
  //             isNaN(value.map_amount) ? '-' :
  //             <FormattedNumber
  //               value={value.map_amount}
  //               minimumFractionDigits={0}
  //               maximumFractionDigits={Number(value.map_token_precision)}
  //             />
  //           }
  //         </span>
  //       }
  //       {
  //         br ? <br/> : ''
  //       }
  //       {
  //         totoken ?
  //           <Link to={`/token/${value.map_token_id}`}>
  //             {
  //               type === 'symbol' ? (
  //                 <span className="mr-1">
  //                   {value.map_token_name_abbr ? value.map_token_name_abbr : value.map_token_name}
  //                 </span>
  //               ) : <span className="mr-1">{value.map_token_name}</span>
  //             }
  //           </Link> :
  //
  //           type === 'symbol' ? (
  //             <span className="mr-1">
  //               {value.map_token_name_abbr ? value.map_token_name_abbr : value.map_token_name}
  //             </span>
  //           ) : <span className="mr-1">{value.map_token_name}</span>
  //       }
  //
  //       {value.map_token_id != 0 && <span style={{color: '#808080', fontSize: '12px'}}>[ID:{value.map_token_id}]</span>}
  //   </span>
  // );
}
