import React from 'react';
// import { FormattedDate, FormattedNumber, FormattedRelative, FormattedTime, injectIntl } from 'react-intl';
import { FormattedDate, FormattedNumber, FormattedTime } from 'react-intl';
import { CHAIN_SYMBOL, ONE_UNIT } from '../../../constants';
import { tu } from '../../../utils/i18n';
import { withTimers } from '../../../utils/timing';
// import { Client } from '../../../services/api';


class TokenInfo extends React.Component {

  // constructor (props) {
  //   super(props);
  //   this.state = {
  //     currentTotalSupply: 0,
  //   };
  // }
  //
  // componentDidMount () {
  //   this.loadTotalTRXSupply();
  // }
  //
  // loadTotalTRXSupply = async () => {
  //   const {funds} = await Client.getBttFundsSupply();
  //   this.setState({
  //     currentTotalSupply: parseInt(funds.totalTurnOver),
  //   });
  // }

  render () {
    let {token} = this.props;
    // let {currentTotalSupply} = this.state;
    // let issued = token.precision ? token.issued / Math.pow(10, token.precision) : token.issued
    // let currentTotal = token.id === '1002000' ? currentTotalSupply : issued;
    let currentTotal = token.precision ? token.issued / Math.pow(10, token.precision) : token.issued
    return (
      <div className="tokenDetail_box">
        <table className="table m-0 tokenDetail">
          <tbody>
          <tr>
            <th style={{borderTop: '0px'}}>{tu('start_date')}:</th>
            <td style={{borderTop: '0px'}}>
              {token.endTime - token.startTime > 1000 ?
                <span>
                  <FormattedDate value={token.startTime}/>&nbsp;
                  <FormattedTime value={token.startTime} hour='numeric' minute="numeric" second='numeric'
                                 hour12={false}/>
                </span> : '-'}
            </td>
          </tr>
          <tr>
            <th>{tu('end_date')}:</th>
            <td>
              {token.endTime - token.startTime > 1000 ?
                <span>
                  <FormattedDate value={token.endTime}/>&nbsp;
                  <FormattedTime value={token.endTime} hour='numeric' minute="numeric" second='numeric' hour12={false}/>
                </span> : '-'}
            </td>
          </tr>
          <tr>
            <th>{tu('price')}:</th>
            <td>
              <FormattedNumber value={((token.trxNum / token.num) * Math.pow(10, token.precision)) / ONE_UNIT}
                               maximumFractionDigits={6}/> {CHAIN_SYMBOL}
            </td>
          </tr>
          <tr>
            <th>{tu('progress')}:</th>
            <td>
              <FormattedNumber value={token.issuedPercentage}/> %
            </td>
          </tr>
          <tr>
            <th>{tu('total_supply')}:</th>
            <td>
              <FormattedNumber
                value={token.precision ? token.totalSupply / Math.pow(10, token.precision) : token.totalSupply}/>
            </td>
          </tr>
          <tr>
            <th>{tu('circulating_supply')}:</th>
            <td>
              <FormattedNumber value={currentTotal}/>
            </td>
          </tr>
          <tr>
            <th>{tu('fund_raised')}:</th>
            <td>
              <FormattedNumber value={token.participated / ONE_UNIT}/> {CHAIN_SYMBOL}
            </td>

          </tr>
          <tr>
            <th>{tu('country')}:</th>
            <td>
              {token.country !== 'no_message' ?
                <span>{token.country ? tu(token.country) : ''} </span> :
                <span>-</span>
              }
            </td>
          </tr>
          <tr>
            <td colSpan="2">
              <i className="fa fa-exclamation-circle" aria-hidden="true"
                 style={{color: '#999999', marginRight: '10px'}}/>
              <span style={{color: '#999999', fontSize: '12px'}}>{tu('change_info')}</span>&nbsp;<a
              href='mailto:contact@mcash.network' style={{color: 'red', fontSize: '12px'}}>{tu('contact_us')}</a></td>
          </tr>

          </tbody>
        </table>
      </div>

    )
  }
}

export default withTimers(TokenInfo);
