import React from 'react';
import {CHAIN_SYMBOL, ONE_UNIT} from '../../../constants';
import {tu} from '../../../utils/i18n';

class CostViewer extends React.Component {

  render() {
    const {cost} = this.props;
    if (!cost) {
      return <div/>
    }
    return (
      JSON.stringify(cost) !== '{}' && (
        <div className="content">
          <div className="content_pos">
            <div className="d-flex border-bottom pt-2">
              <div className="content_box_name">{tu('Fee_Consumption')}</div>
              <div className="flex1">
                {
                  Object.keys(cost).map((c) => {
                    return (c === 'energy_fee' || c === ' bandwidth_fee') ? (
                      <div className="d-flex border-bottom content_item" key={c}>
                        <div className="content_name mr-2" style={{width: 'auto'}}>{tu(c)}:</div>
                        <div className="flex1">{cost[c] / ONE_UNIT} {CHAIN_SYMBOL}</div>
                      </div>
                    ) : (
                      <div className="d-flex border-bottom content_item" key={c}>
                        <div
                          className="content_name mr-2"
                          style={{width: 'auto'}}
                        >{tu(c === 'burning_fee' ? 'Burning Fee' : c)}:
                        </div>
                        <div className="flex1">{c === 'burning_fee' ? cost[c] / ONE_UNIT : cost[c]}</div>
                      </div>
                    )
                  })
                }
              </div>
            </div>
          </div>
        </div>
      )


    )
  }

}

export default CostViewer
