import React from 'react'
import Field from './Field';
import {ONE_UNIT} from '../../../constants'
import {TRXPrice} from '../../common/Price'
import {AddressLink} from '../../common/Links';
import CostViewer from "./CostViewer";

export default class StakeContract extends React.Component {

  render() {
    const {data} = this.props
    return (
      <React.Fragment>
        <div className="card-body table-title">
          <h5>
            <i className="fa fa-exchange-alt"/>
            &nbsp;&nbsp;
            {data.contractType}
          </h5>
        </div>
        <table className="table">
          <tbody>
          {
            data['owner_address'] ?
              <Field label="owner_address"><AddressLink address={data['owner_address']}/></Field>
              : ''
          }
          {
            data['stake_amount'] ?
              <Field label="amount"><TRXPrice amount={data.stake_amount / ONE_UNIT}/></Field>
              : ''
          }
          </tbody>
        </table>
        <CostViewer cost={data.cost}/>
      </React.Fragment>
    )
  }

}
