import React from 'react'
import Field from './Field';
import { TRXPrice } from '../../common/Price'
import { AddressLink } from '../../common/Links';
import { tu } from '../../../utils/i18n';
import { fromAmount } from '../../../utils/helper';

export default class WithdrawBalanceContract extends React.Component {

  render() {
    const {data} = this.props
    return (
      <React.Fragment>
        <div className="card-body table-title">
          <h5>
            <i className="fa fa-exchange-alt"/>
            {tu('withdraw_balance_contract')}
            <small>{tu('withdraw_balance')}</small>
          </h5>
        </div>
        <table className="table">
          <tbody>
          <Field label="owner_address"><AddressLink address={data['owner_address']}/></Field>
          {
            data['result_info'] && data['result_info'].withdraw_amount ?
              <Field label="amount"><TRXPrice amount={fromAmount(data.result_info.withdraw_amount)}/></Field>
              : null
          }
          </tbody>
        </table>
      </React.Fragment>
    )
  }

}
