import {SET_RECENT_TRANSACTIONS, SET_TOKEN_BALANCES, SET_TOTAL_TRANSACTIONS, SET_WEBSOCKET, SET_WS_DATA} from "../actions/account";
import {LOGIN} from "../actions/app";

const initialState = {
  tokens: [],
  mcashBalance: 0,
  totalTransactions: 0,
  recentTransactions: [],
  frozenForBandwidth: {},
  frozenForEnergy:{},
  delegated:{},
  wsdata: []
};

export function accountReducer(state = initialState, action) {

  switch (action.type) {
    case LOGIN: {
      return {
        ...state,
        tokens: [],
      };
    }

    case SET_TOKEN_BALANCES: {
      const {tokens20, tokens, frozenForBandwidth, frozenForEnergy, delegated, mcashBalance} = action
      return {
        ...state,
        tokens20,
        tokens,
        frozenForBandwidth,
        frozenForEnergy,
        delegated,
        mcashBalance
      }
    }

    case SET_TOTAL_TRANSACTIONS: {
      return {
        ...state,
        totalTransactions: action.totalTransactions,
      }
    }

    case SET_RECENT_TRANSACTIONS: {
      return {
        ...state,
        recentTransactions: action.transactions,
      }
    }

    case SET_WEBSOCKET: {
      return {
        ...state,
        websocket: action.socketData,
      }
    }

    case SET_WS_DATA: {
      return {
        ...state,
        wsdata: action.wsdata,
      }
    }

    default:
      return state;
  }
}
