import {FormattedNumber} from "react-intl";
import React from "react";

export const tronAddresses = [
  '27d3byPxZXKQWfXX7sJvemJJuv5M65F3vjS',
  '27fXgQ46DcjEsZ444tjZPKULcxiUfDrDjqj',
  '27SWXcHuQgFf9uv49FknBBBYBaH3DUk4JPx',
  '27WtBq2KoSy5v8VnVZBZHHJcDuWNiSgjbE3',
];

export async function transactionResultManager(transaction, mcashWeb) {
  console.info("transaction input", transaction);
  const signedTransaction = await mcashWeb.mcash.sign(transaction, mcashWeb.defaultPrivateKey).catch(e => {
    return false;
  });
  if (signedTransaction) {
    const broadcast = await mcashWeb.mcash.sendRawTransaction(signedTransaction);

    if (!broadcast.result) {
      broadcast.result = false;
      console.error("error when broadcast transaction ", broadcast);
    }
    return broadcast;
  } else {
    return false;
  }
}


export function FormattedTRX(props) {
  return (
    <FormattedNumber
      maximumFractionDigits={7}
      minimunFractionDigits={7}
      {...props} />
  );
}
