import { upperCase } from 'lodash'
import { tokensMap } from './tokensMap.js';
import xhr from 'axios/index';
import { API_URL } from '../constants.js'
import { CHAIN_SYMBOL, CHAIN_ID, CHAIN_DECIMAL } from '../constants';

const chainSymbol = CHAIN_SYMBOL
const chainID = CHAIN_ID
const chainDecimal = CHAIN_DECIMAL

export default (list = [], tokenId, amount, infolist = false) => {
  let IDmap = {};
  let newList = list ? list.map(item => item) : [];

  const tokenmap = localStorage.getItem('tokensMap');
  IDmap = JSON.parse(tokenmap);

  if (!IDmap) {
    getTokensMap().then(date => {
      IDmap = date
      return reSetData()
    })
  } else {
    return reSetData()
  }

  function reSetData () {
    if (newList) {
      if (typeof tokenId === 'string' && !infolist) {
        newList.map(item => {

          const id = item[tokenId]

          if (id === '_' || upperCase(id) === chainSymbol || id === chainID) {
            setItem(item, chainSymbol, id, chainDecimal, amount ? item[amount] / Math.pow(10, chainDecimal) : 0, chainSymbol, '')
          } else if (IDmap[id]) {
            const list = IDmap[id].split('_&&_')
            setItem(item, list[0], list[1], list[2], amount ? item[amount] / Math.pow(10, list[2]) : 0, list[3], list[4])
          } else if (!IDmap[id] && id !== '_' && upperCase(id) !== chainSymbol && id !== chainID) {
            setItem(item, item[tokenId], item[tokenId], 0, item[amount], item[tokenId], item[tokenId])
          }
          return item
        })
      } else if (infolist) {
        newList.map(obj => {
          obj[infolist].map(item => {
            const id = item[tokenId]

            if (id === '_' || upperCase(id) === chainSymbol || id === chainID) {
              setItem(item, chainSymbol, id, chainDecimal, amount ? item[amount] / Math.pow(10, chainDecimal) : 0, chainSymbol, '')
            } else if (IDmap[id]) {
              const list = IDmap[id].split('_&&_');
              setItem(item, list[0], list[1], list[2], amount ? item[amount] / Math.pow(10, list[2]) : 0, list[3], list[4])
            } else if (!IDmap[id] && id !== '_' && upperCase(id) !== chainSymbol && id !== chainID) {
              setItem(item, item[tokenId], item[tokenId], 0, item[amount], item[tokenId], item[tokenId])
            }
            return item
          })
          return obj
        })
      } else {
        newList.map(item => {
          tokenId.forEach((tid, index) => {
            const id = item[tid]

            if (id === '_' || upperCase(id) === chainSymbol || id === chainID) {
              setItem(item, chainSymbol, id, chainDecimal, amount[index] ? item[amount[index]] / Math.pow(10, chainDecimal) : 0, chainSymbol, '', index)
            } else if (IDmap[id]) {
              const list = IDmap[id].split('_&&_')
              setItem(item, list[0], list[1], list[2], amount[index] ? item[amount[index]] / Math.pow(10, list[2]) : 0, list[3], list[4], index);
            } else if (!IDmap[id] && id !== '_' && upperCase(id) !== chainSymbol) {
              setItem(item, item[tid], 0, 0, item[amount[index]], item[tid], item[tid], index)
            }
          });
          return item
        })
      }
      return newList

    } else {
      console.log('token id is undefined!!')
    }
  }
}

function setItem (item, name, id, pre, amount, symbol, logo, index = 0) {
  index = index === 0 ? '' : index;
  item['map_token_name' + index] = name;
  item['map_token_name_abbr' + index] = symbol;
  item['map_token_id' + index] = id;
  item['map_token_precision' + index] = pre;
  item['map_amount' + index] = amount;
  item['map_amount_logo' + index] = logo;

  return item
}

async function getTokensMap () {
  let {data} = await xhr.get(`${API_URL}/api/tokens?showAll=1&limit=4000`);
  let imgUrl;
  for (let i = 0; i < data.data.length; i++) {
    if (!tokensMap[data.data[i].id]) {
      if (data.data[i].imgUrl) {
        imgUrl = data.data[i].imgUrl
      } else {
        imgUrl = 'https://coin.top/production/js/20190509074813.png'
      }
      tokensMap[data.data[i].id] = data.data[i].name + '_&&_' + data.data[i].id + '_&&_' + data.data[i].precision + '_&&_' + data.data[i].symbol + '_&&_' + imgUrl;
    }
  }
  return tokensMap
}
