import { upperCase } from 'lodash'
import { tokens20Map } from './tokensMap.js';
import xhr from 'axios/index';
import { API_URL } from '../constants.js'
import { CHAIN_DECIMAL, CHAIN_SYMBOL } from '../constants';

export default (list = [], tokenId, amount, infolist = false) => {
  let IDmap = {};
  let newList = list.map(item => item);

  const tokenmap = localStorage.getItem('tokens20Map');
  IDmap = JSON.parse(tokenmap);

  if (!IDmap) {
    getTokensMap().then(date => {
      IDmap = date
      return reSetData()
    })
  } else {
    return reSetData()
  }

  function reSetData () {
    if (newList) {
      if (typeof tokenId === 'string' && !infolist) {
        newList.map(item => {

          const id = item[tokenId]

          if (id === '_' || upperCase(id) === CHAIN_SYMBOL || id === '') {
            setItem(item, CHAIN_SYMBOL, id, CHAIN_DECIMAL, amount ? item[amount] / Math.pow(10, CHAIN_DECIMAL) : 0, CHAIN_SYMBOL, '')
          } else if (IDmap[id]) {
            const list = IDmap[id].split('_&&_')
            setItem(item, list[0], list[1], list[2], amount ? item[amount] / Math.pow(10, list[2]) : 0, list[3], list[4])
          } else if (!IDmap[id] && id !== '_' && upperCase(id) !== CHAIN_SYMBOL && id !== '') {
            setItem(item, item[tokenId], item[tokenId], 0, item[amount], item[tokenId], item[tokenId])
          }
          return item
        })
      } else if (infolist) {
        newList.map(obj => {
          obj[infolist].map(item => {
            const id = item[tokenId]

            if (id === '_' || upperCase(id) === CHAIN_SYMBOL || id === '') {
              setItem(item, CHAIN_SYMBOL, id, CHAIN_DECIMAL, amount ? item[amount] / Math.pow(10, CHAIN_DECIMAL) : 0, CHAIN_SYMBOL, '')
            }
            if (IDmap[id]) {
              const list = IDmap[id].split('_&&_')
              setItem(item, list[0], list[1], list[2], amount ? item[amount] / Math.pow(10, list[2]) : 0, list[3], list[4])
            }
            if (!IDmap[id] && id !== '_' && upperCase(id) !== CHAIN_SYMBOL && id !== '') {
              setItem(item, item[tokenId], item[tokenId], 0, item[amount], item[tokenId], item[tokenId])
            }
            return item
          })
          return obj
        })
      } else {
        newList.map(item => {
          tokenId.map((tid, index) => {
            const id = item[tid]

            if (id === '_' || upperCase(id) === CHAIN_SYMBOL || id === '') {
              setItem(item, CHAIN_SYMBOL, id, CHAIN_DECIMAL, amount[index] ? item[amount[index]] / Math.pow(10, CHAIN_DECIMAL) : 0, CHAIN_SYMBOL, '', index)
            }
            if (IDmap[id]) {
              const list = IDmap[id].split('_&&_')
              setItem(item, list[0], list[1], list[2], amount[index] ? item[amount[index]] / Math.pow(10, list[2]) : 0, list[3], list[4], index)
            }
            if (!IDmap[id] && id !== '_' && upperCase(id) !== CHAIN_SYMBOL) {
              setItem(item, item[tid], 0, 0, item[amount[index]], item[tid], item[tid], index)
            }
          });

          return item
        })
      }
      return newList

    } else {
      console.log('token id is undefined!!')
    }
  }
}


function setItem (item, name, id, pre, amount, symbol, logo, index = '') {
  index = index === 0 ? '' : index;
  item['map_token_name' + index] = name;
  item['map_token_name_abbr' + index] = symbol;
  item['map_token_id' + index] = id;
  item['map_token_precision' + index] = pre;
  item['map_amount' + index] = amount;
  item['map_amount_logo' + index] = logo;

  return item
}

async function getTokensMap () {
  let {data} = await xhr.get(`${API_URL}/api/tokens?start=0&limit=1000&filter=trc20`);
  let imgUrl;
  for (let i = 0; i < data.tokens.length; i++) {
    if (!tokens20Map[data.tokens[i].contractAddress]) {
      if (data.tokens[i].imgUrl) {
        imgUrl = data.tokens[i].imgUrl
      } else {
        imgUrl = 'https://coin.top/production/js/20190509074813.png'
      }
      tokens20Map[data.tokens[i].contractAddress] = data.tokens[i].name + '_&&_' + data.tokens[i].contractAddress + '_&&_' + data.tokens[i].decimal + '_&&_' + data.tokens[i].symbol + '_&&_' + imgUrl;
    }
  }
  return tokens20Map
}
